const cheerio = require('cheerio');
const HeadlessChrome = require('simple-headless-chrome-asksuite')

const browser = new HeadlessChrome({
    headless: true // If you turn this off, you can actually see the browser navigate with your instructions
    // see above if using remote interface
})

async function navigateWebsite(url, idHotel, checkin, checkout, adultos, criancas)  {
    try {
        await browser.init()

        const mainTab = await browser.newTab({ privateTab: false })

        // Navigate to a URL

        if (criancas && criancas === '0'){
            criancas = '';
        }

        let urlBuild = `${url}/D/Reserva?checkin=${checkin}&checkout=${checkout}&cidade=&hotel=${idHotel}&adultos=${adultos}&criancas=${criancas}&promocode=&tarifa=`;

        console.log(urlBuild);

        await mainTab.goTo(urlBuild, {timeout: 20000})


       // await mainTab.waitForPageToLoad(20000)
        await mainTab.waitForSelectorToLoad('#acomodacoesWrapper')



        const htmlTag = await mainTab.evaluate(function(selector) {
            const selectorHtml = document.querySelector(selector)
            return selectorHtml.innerHTML
        }, '#content'); // returns innerHTML of first matching selector for class "main"

    //    console.log(htmlTag.result.value);

        let $ = cheerio.load(htmlTag.result.value);
        let promise = null;

        if ($('#hotel-selecionado-indisponivel-titulo').text() != ""){



            console.log("erro");

            let obj = {
                message: $('#hotel-selecionado-indisponivel-titulo').text()
            };

            promise = await Promise.reject(obj)


        }else{

            let rooms = [];

            $('.row-quarto').each((index, item) => {

                let room = new HotelRoom();

                console.log( $(item).children().length)

                $(item).children().each((index, td) => {


                    if (index == 0){

                        let tdx = $(td);

                        room.name = tdx.find('.quartoNome').text()
                        room.mainPhoto = tdx.find('.imgQuarto').attr('src');
                        room.description = tdx.find('.quartoDescricao').find('p').text()
                        room.amountAdults = tdx.find('.adultos').attr('data-n');
                        room.amountKids = tdx.find('.criancas').attr('data-n');

                        if (room.amountKids == 'no'){
                            room.amountKids = 0;
                        }

                        let str = tdx.find('.imgQuarto').attr('onclick');

                        let idStr = str.replace(/[^0-9,]/g, "").split(",");

                        room.id = idStr[1];


                        let modalMoreInfo = $('#modal-container-'+room.id);

                        modalMoreInfo.find('.amenities-list > .amenity-item').each( (index, itemAmenite) => {
                            room.amenites.push($(itemAmenite).text());
                        })


                        modalMoreInfo.find('#divGaleria > img').each( (index, itemAmenite) => {
                            room.images.push($(itemAmenite).attr('src-full-image'));
                        })


                    }else{


                        let tdx = $(td);
                        room.price = tdx.find('.valorFinal').text();
                        room.total = 'R$ '+ tdx.find('.var-cart-valor-total').val();
                    }

                    console.log("td", room)
                })


                let obj = {
                    data: rooms,
                    url: urlBuild,
                };
                rooms.push(room)

                promise = Promise.resolve(obj)
            })
        }



        // Close the browser
        await browser.close()


        return promise;

    } catch (err) {
        browser.close()
        throw err;
    }
}
//
// navigateWebsite('https://pratasthermas.letsbook.com.br', 12, '27/12/2017', '29/12/2017', 2, 1).then(data => {
//     console.log("sucesso")
// }).catch(error => {
//     console.log("caiu aqui")
//     // console.log(error.code);
// })

class HotelRoom {

    constructor() {
        this.amenites = new Array();
        this.images = new Array();
    }

}




module.exports = {search : navigateWebsite}



